<template functional>
    <div
      :class="[data.class, data.staticClass, 'sf-quantity-selector quan quan']"
      :style="[data.style, data.staticStyle]"
      :aria-label="props.ariaLabel"
    >
      <component
        :is="injections.components.SfButton"
        :disabled="
          props.disabled || Boolean(props.min !== null && props.qty <= props.min)
        "
        class="sf-button--pure sf-quantity-selector__button"
        data-testid="decrease"
        @click="
          $options.handleInput(
            Number(props.qty) - 1,
            listeners,
            props.min,
            props.max
          )
        "
      >
        &minus;
      </component>
      <component
        :is="injections.components.SfInput"
        :name="$options.uniqueKey()"
        :value="props.qty"
        :disabled="props.disabled"
        class="sf-quantity-selector__input"
        data-testid="sf-quantity-selector input"
        @input="$options.handleInput($event, listeners, props.min, props.max)"
        @blur="$options.handleBlur($event, listeners, props.min)"
      />
      <component
        :is="injections.components.SfButton"
        :disabled="
          props.disabled || Boolean(props.max !== null && props.qty >= props.max)
        "
        class="sf-button--pure sf-quantity-selector__button"
        data-testid="increase"
        @click="
          $options.handleInput(
            Number(props.qty) + 1,
            listeners,
            props.min,
            props.max
          )
        "
      >
        +
      </component>
    </div>
  </template>
  <script>
  import { SfInput, SfButton } from "@storefront-ui/vue";
  export default {
    name: "SfQuantitySelector",
    inject: {
      components: {
        default: {
          SfInput,
          SfButton,
        },
      },
    },
    model: {
      prop: "qty",
    },
    props: {
      qty: {
        type: [Number, String],
        default: 1,
      },
      disabled: {
        type: Boolean,
        default: false,
      },
      min: {
        type: Number,
        default: null,
      },
      max: {
        type: Number,
        default: null,
      },
      ariaLabel: {
        type: String,
        default: "Quantity",
      },
    },
    handleInput(val, listeners, min, max) {
      return listeners.input && listeners.input(val);
    },
    handleBlur(event, listeners, min) {
      let val = event.target.value;
      const minimum = min || 1;
      if (val < minimum || isNaN(val)) {
        val = minimum;
      }
      listeners.input && listeners.input(+val);
      return listeners.blur && listeners.blur();
    },
    uniqueKey() {
      const key = Math.random().toString(16).slice(2);
      return "quantitySelector" + key;
    },
  };
  </script>
  <style lang="scss">
  @import "~@storefront-ui/shared/styles/components/atoms/SfQuantitySelector.scss";
  </style>
  